/**
 * @returns {DocumentFragment}
 */
App.MainView.errors = function() {
	const fragment = document.createDocumentFragment();

	/**
	 * @returns {HTMLParagraphElement}
	 */
	function newError() {
		const error = document.createElement("p");
		fragment.append(error);
		return error;
	}

	// check for correct version
	if (V.releaseID >= 1000 || ["0.9", "0.8", "0.7", "0.6"].includes(V.ver)) {
		if (V.releaseID < App.Version.release) {
			newError().append(App.UI.DOM.makeElement("span", "INCOMPATIBILITY WARNING:", "major-warning"),
				` Your saved game was created using version: ${V.ver}, build: ${V.releaseID}. You must run `,
				App.UI.DOM.passageLink("Backwards Compatibility", "Backwards Compatibility"));
		}
	} else {
		newError().append(App.UI.DOM.makeSpan("INCOMPATIBLE SAVE WARNING:", "major-warning"),
			` Your saved game was created using version: ${V.ver}, and you are using a later version which New Game Plus cannot reconcile. Please start a new game.`);
	}

	// check for correct rules
	if (V.defaultRules.length > 0 && (V.defaultRules[0].condition === undefined || V.defaultRules[0].set === undefined)) {
		const error = newError();
		error.append(App.UI.DOM.makeElement("span", "INCOMPATIBILITY WARNING:", "major-warning"),
			" The rules assistant format has changed. In the Options Menu, please ");
		const ra = document.createElement("strong");
		ra.append("Reset RA Rules");
		error.append(ra);
	}

	// check for NaN
	if (V.NaNArray.length > 0) {
		const error = newError();
		error.id = "NaNArray";
		error.append(App.UI.DOM.makeElement("span", "ERROR: The following variables are NaN! Please report this.", "error"));
		V.NaNArray.forEach(e => {
			const div = document.createElement("div");
			div.append(e);
			error.append(div);
		});
		error.append(App.UI.DOM.link("Hide NaN variables until next week",
			() => {
				error.outerHTML = "";
				V.NaNArray = [];
			})
		);
	}

	// check custom slaves
	if (App.Utils.IsCustomSlaveMutated(V.customSlave)) {
		newError().append(App.UI.DOM.makeElement("span", "ERROR: Your custom slave order has taken on a mutated life of its own and has been summarily shot. Refile your custom slave order, if necessary, and notify the appropriate authorities if you see this message again.", "error"));
		V.customSlave = new App.Entity.CustomSlaveOrder();
	}
	if (App.Utils.IsCustomSlaveMutated(V.huskSlave)) {
		newError().append(App.UI.DOM.makeElement("span", "ERROR: Your husk slave order has taken on a mutated life of its own and has been summarily shot. Refile your husk slave order, if necessary, and notify the appropriate authorities if you see this message again.", "error"));
		V.huskSlave = new App.Entity.CustomSlaveOrder();
	}

	return fragment;
};

/**
 * @return {Text}
 */
App.MainView.fcnn = function() {
	let text;

	if (V.FCNNstation !== 1 && V.week >= 90) {
		text = "FCNN: FCNN service has been temporarily suspended. Please stand by.";
	} else {
		text = V.fcnn.random();
	}

	return document.createTextNode(`${text} `);
};

/**
 * @return {HTMLDivElement}
 */
App.MainView.useGuard = function() {
	const guard = V.slaves[V.slaveIndices[V.Bodyguard.ID]];

	const outerDiv = document.createElement("div");

	if (guard === undefined || guard.assignment !== "guard you" || V.useSlaveSummaryOverviewTab === 1) {
		return outerDiv;
	}

	App.UI.DOM.appendNewElement("span", App.Interact.guardPose(guard), outerDiv, "scene-intro");

	function setEnvironment() {
		V.activeSlave = guard;
		V.nextButton = "Back";
		V.nextLink = "AS Dump";
		V.returnTo = passage();
	}

	const {him, his} = getPronouns(guard);
	const optionDiv = document.createElement("div");
	optionDiv.classList.add("indent");

	optionDiv.append(
		App.UI.DOM.passageLink(`Use ${his} mouth`, "FLips", setEnvironment),
		" | ",
		App.UI.DOM.passageLink(`Play with ${his} tits`, "FBoobs", setEnvironment)
	);

	if (canDoVaginal(guard)) {
		optionDiv.append(" | ", App.UI.DOM.passageLink(`Fuck ${him}`, "FVagina", setEnvironment));
		if (canDoAnal(guard)) {
			optionDiv.append(" | ", App.UI.DOM.passageLink(`Use ${his} holes`, "FButt", setEnvironment));
		}
		if (guard.belly >= 300000) {
			optionDiv.append(" | ", App.UI.DOM.passageLink(`Fuck ${him} over ${his} belly`, "FBellyFuck", setEnvironment));
		}
	}

	if (canPenetrate(guard)) {
		optionDiv.append(" | ", App.UI.DOM.passageLink(`Ride ${him}`, "FDick", setEnvironment));
	}
	if (canDoAnal(guard)) {
		optionDiv.append(" | ", App.UI.DOM.passageLink(`Fuck ${his} ass`, "FAnus", setEnvironment));
	}
	optionDiv.append(" | ", App.UI.DOM.passageLink(`Abuse ${him}`, "Gameover", () => { V.gameover = "idiot ball"; }));

	outerDiv.append(optionDiv);

	return outerDiv;
};
